;
;  ALU_ASM.MZF - 10.6.2018 by Mds.
;
_CR:            equ     0x0d
;
ALU_DATA:       equ     26h
ALU_CMD:        equ     ALU_DATA+1

ALU_BUSY:       equ     80h
ALU_NEGATIVE:   equ     40h
ALU_ZERO:       equ     20h
ALU_UNDERFLOW:  equ     04h
ALU_OVERFLOW:   equ     02h
ALU_CARRY:      equ     01h

SMUL:           equ     03h
SQRT:           equ     10h
LOG:            equ     18h
LN:             equ     19h
EXP:            equ     1ah
PWR:            equ     1bh
PI:             equ     2ah

; MZF header
	org     START-0x80
;
	db	1                   ; OBJ file
	db	'ALU-ASM.MZF'
	db	_CR, _CR, _CR, _CR, _CR, _CR
	dw	PRGEND-START
	dw	START
	dw	START
        ds      104, 0
;
        org     2000h
;
START:
                ld      a, SQRT
                push    bc
                ld      hl, FP_10
                call    PUSHFP
                call    CMDFP
                ld      hl, DATA1
                call    POPFP

                ld      a, SMUL
                ld      hl, FP_10
                call    PUSHFP
                ld      hl, FP_PI
                call    PUSHFP
                call    CMDFP
                ld      hl, DATA2
                call    POPFP

                ld      a, SMUL
                ld      hl, FP_10
                ld      de, FP_PI
                call    PATH_AB

                pop     bc
                jp      0e804h                      ; go monitor
;
;
PATCH_SQR:      ld      a, SQRT
PATH_A:         push    bc
                call    PUSHFP
                call    CMDFP
                call    POPFP
                pop     bc
                ret
;
CMDFP:          out     (ALU_CMD), a

CMD_W:          in      a, (ALU_CMD)
                rl      a
                jr      c, CMD_W

                ret
;
PUSHFP:         push    hl
                ld      bc, 5*256+ALU_DATA
                otir
                pop     hl
                ret
;
POPFP:          push    hl
                ld      bc, 5*256+ALU_DATA
                inir
                pop     hl
                ret
;
FP_PI:          db      82h, 49h, 0fh, 0dah, 0a2h       ; 3.1415926
FP_10:          db      84h, 20h, 00h, 00h, 00h         ; 10

DATA1:          ds      5
DATA2:          ds      5

BUSY_CNT:       db      1
;
;
FLEXIT:         equ     90fah

PLUSMINUS:      or      a
                ld      a, 01           ; SADD
                jr      z, PL_PLS
                ld      a, 02           ; SSUB
PL_PLS:         call    PATH_AB
                jp      FLEXIT
;
;
        org     57d0h           ; 5850h
;
; (HL) = arg
; A = operation
PATH_A1:        push    bc
                push    hl

                push    hl
PATH0:          ld      bc, 5*256+ALU_DATA
                otir

                out     (ALU_CMD), a

CMD_W1:         in      a, (ALU_CMD)
                rl      a
                jr      c, CMD_W1

                ld      b, 5
                pop     hl
                inir

                pop     hl
                pop     bc
                ret
;
;               PUSHFP (HL); PUSHFP (DE); MATH_OP; POPFP (HL)
; (DE) = argA
; (HL) = argB
; A = operation
PATH_AB:        push    bc
                push    hl

                push    hl
                push    de
                ld      bc, 5*256+ALU_DATA
                otir
                pop     hl

                jr      PATH0
;
PRGEND:
	end
